
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "global",
    "inkarnationen",
    "metaDaten"
})
public class StartStoppSkript implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("global")
    private Global global;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationen")
    private List<Inkarnation> inkarnationen = new ArrayList<Inkarnation>();
    @JsonProperty("metaDaten")
    private MetaDaten metaDaten;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 8719286284944672525L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartStoppSkript() {
    }

    /**
     * 
     * @param inkarnationen
     * @param metaDaten
     * @param global
     */
    public StartStoppSkript(Global global, List<Inkarnation> inkarnationen, MetaDaten metaDaten) {
        super();
        this.global = global;
        this.inkarnationen = inkarnationen;
        this.metaDaten = metaDaten;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("global")
    public Global getGlobal() {
        return global;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("global")
    public void setGlobal(Global global) {
        this.global = global;
    }

    public StartStoppSkript withGlobal(Global global) {
        this.global = global;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationen")
    public List<Inkarnation> getInkarnationen() {
        return inkarnationen;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationen")
    public void setInkarnationen(List<Inkarnation> inkarnationen) {
        this.inkarnationen = inkarnationen;
    }

    public StartStoppSkript withInkarnationen(List<Inkarnation> inkarnationen) {
        this.inkarnationen = inkarnationen;
        return this;
    }

    @JsonProperty("metaDaten")
    public MetaDaten getMetaDaten() {
        return metaDaten;
    }

    @JsonProperty("metaDaten")
    public void setMetaDaten(MetaDaten metaDaten) {
        this.metaDaten = metaDaten;
    }

    public StartStoppSkript withMetaDaten(MetaDaten metaDaten) {
        this.metaDaten = metaDaten;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartStoppSkript withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("global", global).append("inkarnationen", inkarnationen).append("metaDaten", metaDaten).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(global).append(additionalProperties).append(inkarnationen).append(metaDaten).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartStoppSkript) == false) {
            return false;
        }
        StartStoppSkript rhs = ((StartStoppSkript) other);
        return new EqualsBuilder().append(global, rhs.global).append(additionalProperties, rhs.additionalProperties).append(inkarnationen, rhs.inkarnationen).append(metaDaten, rhs.metaDaten).isEquals();
    }

}
